(*** Solution for the exercise no 1.1, ICP, of May, 12 ***)
(***       Accuracy in Numerical Differentiation       ***)
(***             Matthias Jamin, 10.5.2003             ***)

(* Call the three functions with DoSin, DoExp, DoLog *)

Print[ "Call 'DoSin', 'DoExp', or 'DoLog'."];


(* Normal and symmetric numerical derivative of Sin[x] at 1 *)

sinp = Cos[1.];

sinpn[h_] := (Sin[1.+h]-Sin[1.])/h;
sinps[h_] := (Sin[1.+h]-Sin[1.-h])/(2h);

DoSin := Do[ Print[ n, "   ",
                    sinpn[10^(-n)]-sinp, "   ",
                    sinps[10^(-n)]-sinp], {n,1,18}];


(* Normal and symmetric numerical derivative of Exp[x] at 1 *)

expp = Exp[1.];

exppn[h_] := (Exp[1.+h]-Exp[1.])/h;
expps[h_] := (Exp[1.+h]-Exp[1.-h])/(2h);

DoExp := Do[ Print[ n, "   ",
                    exppn[10^(-n)]-expp, "   ",
                    expps[10^(-n)]-expp], {n,1,18}];


(* Normal and symmetric numerical derivative of Log[x] at 1 *)

logp = 1.;

logpn[h_] := (Log[1.+h]-Log[1.])/h;
logps[h_] := (Log[1.+h]-Log[1.-h])/(2h);

DoLog := Do[ Print[ n, "   ",
                    logpn[10^(-n)]-logp, "   ",
                    logps[10^(-n)]-logp], {n,1,18}];

(* End *)
