(*** Solution for the exercise no 10.2, ICP, of July 18 ***)
(***                  Fourier Transform                 ***)
(***              Matthias Jamin, 18.7.2003             ***)

(* Solve the differential equation for Duffings oscillator *)

B = 2;

duff = NDSolve[ { x''[t] + x'[t] + x[t]^3 == B Cos[t],
                  x[0] == 1, x'[0] == 0}, x, {t,0,60},
                  AccuracyGoal->16, MaxSteps->3000]

plot := Plot[ x[t] /. duff[[1]], {t,0,60}];

