C-----------------------------------------------------------------------
      Subroutine polint(xa,ya,x,y,dy,n)
      Implicit Double Precision (A-z)
      Integer i, n, ns, nmax
      Parameter (nmax=10)
      Dimension xa(n), ya(n), c(nmax), d(nmax)
      !
      ns=1
      dif = dabs(x-xa(1))
      Do 11 i=1,n
         dift = dabs(x-xa(i))
         If (dift.lt.dif) Then
            ns = i
            dif = dift
         End If
         c(i) = ya(i)
         d(i) = ya(i)
   11 Continue
      !
      y = ya(ns)
      ns = ns-1
      Do 13 m=1,n-1
         Do 12 i=1,n-m
            ho = xa(i)-x
            hp = xa(i+m)-x
            w = c(i+1)-d(i)
            den = ho-hp
            If (den.eq.0.D0) Pause 'Failure in polint.'
            den = w/den
            d(i) = hp*den
            c(i) = ho*den
   12    Continue
         If (2*ns.lt.n-m) Then
            dy = c(ns+1)
         Else
            dy = d(ns)
            ns = ns-1
         End If
         y = y+dy
   13 Continue
      !
      Return
      End
C-----------------------------------------------------------------------
