C-----------------------------------------------------------------------
      Subroutine tridag(a,b,c,r,u,n)
      Implicit Double Precision (A-z)
      Integer j, n, NMAX
      Dimension a(n), b(n), c(n), r(n), u(n), gam(NMAX)
      Parameter (NMAX=500)
      !
      If (b(1).eq.0.D0) Pause 'tridag: rewrite equations'
      bet = b(1)
      u(1) = r(1)/bet
      Do 11 j = 2,n
         gam(j) = c(j-1)/bet
         bet = b(j)-a(j)*gam(j)
         If (bet.eq.0.D0) Pause 'tridag failed'
         u(j) = (r(j)-a(j)*u(j-1))/bet
   11 Continue
      Do 12 j = n-1,1,-1
         u(j) = u(j)-gam(j+1)*u(j+1)
   12 Continue
      Return
      End
C-----------------------------------------------------------------------
